package org.greenstone.gsdl3.gs3build;

import java.io.File;

public class FileCrawler
{
  File root;
  FileCrawlObserver observer;

  public FileCrawler(File file, FileCrawlObserver observer)
  { this.root = file;
    this.observer = observer;
  }

  public void crawl()
  { this.crawlDirectory(this.root);
  }

  public boolean crawlDirectory(File file)
  {
    File [] children = file.listFiles();

    if (children == null) {
      return true;
    }

    for (int c = 0; c < children.length; c ++) {
      if (children[c].isDirectory()) {
	crawlDirectory(children[c]);
      }
      else
      {
	// TODO: process file
	this.observer.processFile(children[c]);
      }
    }
    return true;
  }
}
