package org.greenstone.gsdl3.gs3build.expander;

import java.io.File;
import java.net.URL;

import org.greenstone.gsdl3.gs3build.BuildManager;

public interface ExpanderInterface
{
	/**
	 *  Record the build manager to use for this expander - this is used
	 *  to pass back any new directories into which expanded files are placed.
	 */
	public void configure(BuildManager manager);

	/**
	 *  Attempt to expand a file.  The returned result is <code>true</code> if the
	 *  file was actually expanded.
	 *
	 *  @param <code>URL</code> the name of the file, or its URL
	 *  @param <code>File</code> the directory to expand files into - the expander
	 *         should create its own sub-directory to ensure that no later conflicts
	 *         emerge.
	 *
	 *  @return <code>boolean</code> whether the file was expanded.
	 */
	public boolean expandFile(URL fileReference, File expansionDirectory);
}